---
name: customers-routes
description: Handle 47 OpenAPI operation(s) under /v1/customers for the customers route group.
---

# customers API Routes

Handle 47 OpenAPI operation(s) under /v1/customers for the customers route group.

Use the generated operation tools to make real API calls. Do not invent API responses.
If a tool reports missing setup, return the exact setup field name to the caller.
For write, update, or delete operations, state the intended action before calling the tool.

## Operations

### get_customers

- Operation ID: `get_customers`
- Route: `GET /v1/customers`
- Mode: READ
- Summary: List all customers
- Parameters:
  - `created` in `query`
  - `email` in `query`
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
  - `test_clock` in `query`
- Body: JSON request body accepted.

### post_customers

- Operation ID: `post_customers`
- Route: `POST /v1/customers`
- Mode: WRITE
- Summary: Create a customer
- Body: JSON request body accepted.

### get_customers_search

- Operation ID: `get_customers_search`
- Route: `GET /v1/customers/search`
- Mode: READ
- Summary: Search customers
- Parameters:
  - `expand` in `query`
  - `limit` in `query`
  - `page` in `query`
  - `query` in `query` required
- Body: JSON request body accepted.

### delete_customers_customer

- Operation ID: `delete_customers_customer`
- Route: `DELETE /v1/customers/{customer}`
- Mode: WRITE
- Summary: Delete a customer
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer

- Operation ID: `get_customers_customer`
- Route: `GET /v1/customers/{customer}`
- Mode: READ
- Summary: Retrieve a customer
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
- Body: JSON request body accepted.

### post_customers_customer

- Operation ID: `post_customers_customer`
- Route: `POST /v1/customers/{customer}`
- Mode: WRITE
- Summary: Update a customer
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_balance_transactions

- Operation ID: `get_customers_customer_balance_transactions`
- Route: `GET /v1/customers/{customer}/balance_transactions`
- Mode: READ
- Summary: List customer balance transactions
- Parameters:
  - `created` in `query`
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `invoice` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_balance_transactions

- Operation ID: `post_customers_customer_balance_transactions`
- Route: `POST /v1/customers/{customer}/balance_transactions`
- Mode: WRITE
- Summary: Create a customer balance transaction
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_balance_transactions_transaction

- Operation ID: `get_customers_customer_balance_transactions_transaction`
- Route: `GET /v1/customers/{customer}/balance_transactions/{transaction}`
- Mode: READ
- Summary: Retrieve a customer balance transaction
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `transaction` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_balance_transactions_transaction

- Operation ID: `post_customers_customer_balance_transactions_transaction`
- Route: `POST /v1/customers/{customer}/balance_transactions/{transaction}`
- Mode: WRITE
- Summary: Update a customer credit balance transaction
- Parameters:
  - `customer` in `path` required
  - `transaction` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_bank_accounts

- Operation ID: `get_customers_customer_bank_accounts`
- Route: `GET /v1/customers/{customer}/bank_accounts`
- Mode: READ
- Summary: List all bank accounts
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_bank_accounts

- Operation ID: `post_customers_customer_bank_accounts`
- Route: `POST /v1/customers/{customer}/bank_accounts`
- Mode: WRITE
- Summary: Create a card
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_bank_accounts_id

- Operation ID: `delete_customers_customer_bank_accounts_id`
- Route: `DELETE /v1/customers/{customer}/bank_accounts/{id}`
- Mode: WRITE
- Summary: Delete a customer source
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_bank_accounts_id

- Operation ID: `get_customers_customer_bank_accounts_id`
- Route: `GET /v1/customers/{customer}/bank_accounts/{id}`
- Mode: READ
- Summary: Retrieve a bank account
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_bank_accounts_id

- Operation ID: `post_customers_customer_bank_accounts_id`
- Route: `POST /v1/customers/{customer}/bank_accounts/{id}`
- Mode: WRITE
- Summary: <p>Update a specified source for a given customer.</p>
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_bank_accounts_id_verify

- Operation ID: `post_customers_customer_bank_accounts_id_verify`
- Route: `POST /v1/customers/{customer}/bank_accounts/{id}/verify`
- Mode: WRITE
- Summary: Verify a bank account
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_cards

- Operation ID: `get_customers_customer_cards`
- Route: `GET /v1/customers/{customer}/cards`
- Mode: READ
- Summary: List all cards
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_cards

- Operation ID: `post_customers_customer_cards`
- Route: `POST /v1/customers/{customer}/cards`
- Mode: WRITE
- Summary: Create a card
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_cards_id

- Operation ID: `delete_customers_customer_cards_id`
- Route: `DELETE /v1/customers/{customer}/cards/{id}`
- Mode: WRITE
- Summary: Delete a customer source
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_cards_id

- Operation ID: `get_customers_customer_cards_id`
- Route: `GET /v1/customers/{customer}/cards/{id}`
- Mode: READ
- Summary: Retrieve a card
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_cards_id

- Operation ID: `post_customers_customer_cards_id`
- Route: `POST /v1/customers/{customer}/cards/{id}`
- Mode: WRITE
- Summary: <p>Update a specified source for a given customer.</p>
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_cash_balance

- Operation ID: `get_customers_customer_cash_balance`
- Route: `GET /v1/customers/{customer}/cash_balance`
- Mode: READ
- Summary: Retrieve a cash balance
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
- Body: JSON request body accepted.

### post_customers_customer_cash_balance

- Operation ID: `post_customers_customer_cash_balance`
- Route: `POST /v1/customers/{customer}/cash_balance`
- Mode: WRITE
- Summary: Update a cash balance's settings
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_cash_balance_transactions

- Operation ID: `get_customers_customer_cash_balance_transactions`
- Route: `GET /v1/customers/{customer}/cash_balance_transactions`
- Mode: READ
- Summary: List cash balance transactions
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### get_customers_customer_cash_balance_transactions_transaction

- Operation ID: `get_customers_customer_cash_balance_transactions_transaction`
- Route: `GET /v1/customers/{customer}/cash_balance_transactions/{transaction}`
- Mode: READ
- Summary: Retrieve a cash balance transaction
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `transaction` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_discount

- Operation ID: `delete_customers_customer_discount`
- Route: `DELETE /v1/customers/{customer}/discount`
- Mode: WRITE
- Summary: Delete a customer discount
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_discount

- Operation ID: `get_customers_customer_discount`
- Route: `GET /v1/customers/{customer}/discount`
- Mode: READ
- Summary: GetCustomersCustomerDiscount
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
- Body: JSON request body accepted.

### post_customers_customer_funding_instructions

- Operation ID: `post_customers_customer_funding_instructions`
- Route: `POST /v1/customers/{customer}/funding_instructions`
- Mode: WRITE
- Summary: Create or retrieve funding instructions for a customer cash balance
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_payment_methods

- Operation ID: `get_customers_customer_payment_methods`
- Route: `GET /v1/customers/{customer}/payment_methods`
- Mode: READ
- Summary: List a Customer's PaymentMethods
- Parameters:
  - `allow_redisplay` in `query`
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
  - `type` in `query`
- Body: JSON request body accepted.

### get_customers_customer_payment_methods_payment_method

- Operation ID: `get_customers_customer_payment_methods_payment_method`
- Route: `GET /v1/customers/{customer}/payment_methods/{payment_method}`
- Mode: READ
- Summary: Retrieve a Customer's PaymentMethod
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `payment_method` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_sources

- Operation ID: `get_customers_customer_sources`
- Route: `GET /v1/customers/{customer}/sources`
- Mode: READ
- Summary: <p>List sources for a specified customer.</p>
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `object` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_sources

- Operation ID: `post_customers_customer_sources`
- Route: `POST /v1/customers/{customer}/sources`
- Mode: WRITE
- Summary: Create a card
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_sources_id

- Operation ID: `delete_customers_customer_sources_id`
- Route: `DELETE /v1/customers/{customer}/sources/{id}`
- Mode: WRITE
- Summary: Delete a customer source
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_sources_id

- Operation ID: `get_customers_customer_sources_id`
- Route: `GET /v1/customers/{customer}/sources/{id}`
- Mode: READ
- Summary: <p>Retrieve a specified source for a given customer.</p>
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_sources_id

- Operation ID: `post_customers_customer_sources_id`
- Route: `POST /v1/customers/{customer}/sources/{id}`
- Mode: WRITE
- Summary: <p>Update a specified source for a given customer.</p>
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_sources_id_verify

- Operation ID: `post_customers_customer_sources_id_verify`
- Route: `POST /v1/customers/{customer}/sources/{id}/verify`
- Mode: WRITE
- Summary: Verify a bank account
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_subscriptions

- Operation ID: `get_customers_customer_subscriptions`
- Route: `GET /v1/customers/{customer}/subscriptions`
- Mode: READ
- Summary: List active subscriptions
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_subscriptions

- Operation ID: `post_customers_customer_subscriptions`
- Route: `POST /v1/customers/{customer}/subscriptions`
- Mode: WRITE
- Summary: Create a subscription
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_subscriptions_subscription_exposed_id

- Operation ID: `delete_customers_customer_subscriptions_subscription_exposed_id`
- Route: `DELETE /v1/customers/{customer}/subscriptions/{subscription_exposed_id}`
- Mode: WRITE
- Summary: Cancel a subscription
- Parameters:
  - `customer` in `path` required
  - `subscription_exposed_id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_subscriptions_subscription_exposed_id

- Operation ID: `get_customers_customer_subscriptions_subscription_exposed_id`
- Route: `GET /v1/customers/{customer}/subscriptions/{subscription_exposed_id}`
- Mode: READ
- Summary: Retrieve a subscription
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `subscription_exposed_id` in `path` required
- Body: JSON request body accepted.

### post_customers_customer_subscriptions_subscription_exposed_id

- Operation ID: `post_customers_customer_subscriptions_subscription_exposed_id`
- Route: `POST /v1/customers/{customer}/subscriptions/{subscription_exposed_id}`
- Mode: WRITE
- Summary: Update a subscription on a customer
- Parameters:
  - `customer` in `path` required
  - `subscription_exposed_id` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_subscriptions_subscription_exposed_id_discount

- Operation ID: `delete_customers_customer_subscriptions_subscription_exposed_id_discount`
- Route: `DELETE /v1/customers/{customer}/subscriptions/{subscription_exposed_id}/discount`
- Mode: WRITE
- Summary: Delete a customer discount
- Parameters:
  - `customer` in `path` required
  - `subscription_exposed_id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_subscriptions_subscription_exposed_id_discount

- Operation ID: `get_customers_customer_subscriptions_subscription_exposed_id_discount`
- Route: `GET /v1/customers/{customer}/subscriptions/{subscription_exposed_id}/discount`
- Mode: READ
- Summary: GetCustomersCustomerSubscriptionsSubscriptionExposedIdDiscount
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `subscription_exposed_id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_tax_ids

- Operation ID: `get_customers_customer_tax_ids`
- Route: `GET /v1/customers/{customer}/tax_ids`
- Mode: READ
- Summary: List all Customer tax IDs
- Parameters:
  - `customer` in `path` required
  - `ending_before` in `query`
  - `expand` in `query`
  - `limit` in `query`
  - `starting_after` in `query`
- Body: JSON request body accepted.

### post_customers_customer_tax_ids

- Operation ID: `post_customers_customer_tax_ids`
- Route: `POST /v1/customers/{customer}/tax_ids`
- Mode: WRITE
- Summary: Create a Customer tax ID
- Parameters:
  - `customer` in `path` required
- Body: JSON request body accepted.

### delete_customers_customer_tax_ids_id

- Operation ID: `delete_customers_customer_tax_ids_id`
- Route: `DELETE /v1/customers/{customer}/tax_ids/{id}`
- Mode: WRITE
- Summary: Delete a Customer tax ID
- Parameters:
  - `customer` in `path` required
  - `id` in `path` required
- Body: JSON request body accepted.

### get_customers_customer_tax_ids_id

- Operation ID: `get_customers_customer_tax_ids_id`
- Route: `GET /v1/customers/{customer}/tax_ids/{id}`
- Mode: READ
- Summary: Retrieve a Customer tax ID
- Parameters:
  - `customer` in `path` required
  - `expand` in `query`
  - `id` in `path` required
- Body: JSON request body accepted.
